package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.set.AWORSet;
import org.bdware.sc.crdt.SharableVarState;

import java.util.Set;

public class AWORSetProxy extends SharableVar<AWORSet<Object>> {
    public AWORSetProxy(String varId, String cpId, SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new AWORSet<>(cpId, varId);
    }

    public void add(Object val) {
        AWORSet<Object> delta = self.add(val);
        localDeltaQueue.add(delta);
    }

    public void remove(Object val) {
        AWORSet<Object> delta = self.remove(val);
        localDeltaQueue.add(delta);
    }

    public Set<Object> read() {
        return self.read();
    }

    @Override
    protected AWORSet<Object> newEmptyDelta() {
        return new AWORSet<>(null, varId);
    }
}
