package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.flag.DWFlag;
import org.bdware.sc.crdt.SharableVarState;

public class DWFlagProxy extends SharableVar<DWFlag> {
    public DWFlagProxy(String varId, String cpId, SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new DWFlag(cpId, varId);
    }

    public void enable() {
        DWFlag delta = self.enable();
        localDeltaQueue.add(delta);
    }

    public void disable() {
        DWFlag delta = self.disable();
        localDeltaQueue.add(delta);
    }

    public boolean read() {
        return self.read();
    }

    @Override
    protected DWFlag newEmptyDelta() {
        return new DWFlag(null, varId);
    }
}
