package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.flag.EWFlag;
import org.bdware.sc.crdt.SharableVarState;

public class EWFlagProxy extends SharableVar<EWFlag> {
    public EWFlagProxy(String varId, String cpId, SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new EWFlag(cpId, varId);
    }

    public void enable() {
        EWFlag delta = self.enable();
        localDeltaQueue.add(delta);
    }

    public void disable() {
        EWFlag delta = self.disable();
        localDeltaQueue.add(delta);
    }

    public boolean read() {
        return self.read();
    }

    @Override
    protected EWFlag newEmptyDelta() {
        return new EWFlag(null, varId);
    }
}
