package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.counter.GCounter;
import org.bdware.sc.crdt.SharableVarState;

public class GCounterProxy extends SharableVar<GCounter> {

    public GCounterProxy(String varId, String cpId,
            SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new GCounter(cpId, varId);
    }

    public void inc() {
        GCounter delta = self.inc();
        localDeltaQueue.add(delta);
    }

    public void inc(long var) {
        GCounter delta = self.inc(var);
        localDeltaQueue.add(delta);
    }

    public Long read() {
        return self.read();
    }

    @Override
    protected GCounter newEmptyDelta() {
        return new GCounter(null, varId);
    }
}
