package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.set.GSet;
import org.bdware.sc.crdt.SharableVarState;

import java.util.Set;

public class GSetProxy extends SharableVar<GSet<Object>> {
    public GSetProxy(String varId, String cpId, SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new GSet<>(cpId, varId);
    }

    public void add(Object val) {
        GSet<Object> delta = self.add(val);
        localDeltaQueue.add(delta);
    }

    public Set<Object> read() {
        return self.read();
    }

    @Override
    protected GSet<Object> newEmptyDelta() {
        return new GSet<>(null, varId);
    }
}
