package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.register.LWWRegister;
import org.bdware.sc.crdt.SharableVarState;

public class LWWRegisterProxy extends SharableVar<LWWRegister<Long, Object>> {
    public LWWRegisterProxy(String varId, String cpId,
            SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new LWWRegister<>(cpId, varId);
    }

    public void write(Object val) {
        LWWRegister<Long, Object> delta = self.write(System.currentTimeMillis(), val);
        localDeltaQueue.add(delta);
    }

    public Object read() {
        return self.read();
    }

    @Override
    protected LWWRegister<Long, Object> newEmptyDelta() {
        return new LWWRegister<>(null, varId);
    }
}
