package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.counter.PNCounter;
import org.bdware.sc.crdt.SharableVarState;

public class PNCounterProxy extends SharableVar<PNCounter> {
    public PNCounterProxy(String varId, String cpId,
            SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new PNCounter(cpId, varId);
    }

    public void inc() {
        PNCounter delta = self.inc();
        localDeltaQueue.add(delta);
    }

    public void inc(long val) {
        PNCounter delta = self.inc(val);
        localDeltaQueue.add(delta);
    }

    public void dec() {
        PNCounter delta = self.dec();
        localDeltaQueue.add(delta);
    }

    public void dec(long val) {
        PNCounter delta = self.dec(val);
        localDeltaQueue.add(delta);
    }

    public Long read() {
        return self.read();
    }

    @Override
    protected PNCounter newEmptyDelta() {
        return new PNCounter(null, varId);
    }
}
