package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.set.RWLWWSet;
import org.bdware.sc.crdt.SharableVarState;

import java.util.Set;

public class RWLWWSetProxy extends SharableVar<RWLWWSet<Long, Object>> {
    public RWLWWSetProxy(String varId, String cpId,
            SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new RWLWWSet<>(cpId, varId);
    }

    public void add(Object val) {
        RWLWWSet<Long, Object> delta = self.add(System.currentTimeMillis(), val);
        localDeltaQueue.add(delta);
    }

    public void remove(Object val) {
        RWLWWSet<Long, Object> delta = self.remove(System.currentTimeMillis(), val);
        localDeltaQueue.add(delta);
    }

    public Set<Object> read() {
        return self.read();
    }

    @Override
    protected RWLWWSet<Long, Object> newEmptyDelta() {
        return new RWLWWSet<>();
    }
}
