package org.bdware.sc.crdt.proxy;

import org.bdware.crdt.set.TPSet;
import org.bdware.sc.crdt.SharableVarState;

import java.util.Set;

public class TPSetProxy extends SharableVar<TPSet<Object>> {
    public TPSetProxy(String varId, String cpId, SharableVarState.SharableVarConfiguration conf) {
        super(varId, cpId, conf);
        self = new TPSet<>(cpId, varId);
    }

    public void add(Object val) {
        TPSet<Object> delta = self.add(val);
        localDeltaQueue.add(delta);
    }

    public void remove(Object val) {
        TPSet<Object> delta = self.remove(val);
        localDeltaQueue.add(delta);
    }

    public Set<Object> read() {
        return self.read();
    }

    @Override
    protected TPSet<Object> newEmptyDelta() {
        return new TPSet<>(null, varId);
    }
}
